{% extends "partials/layout.html" %}
{% block content %}

<a style="text-decoration: none;" href="https://www.w3.org/TR/2013/REC-sparql11-query-20130321/#basicpatterns">
	<img src="static/sparql.svg" style="max-width: 64px"/>
</a>
<a style="text-decoration: none;" href="https://www.w3.org/TR/turtle/">
	<img src="static/turtle.svg" style="max-width: 64px"/>
</a>

<h2>File Index</h2>
<p>
	This table provides an overview over all files stored in the 
	Coscine Resource <i>{{resource}}</i>. Although directories are excluded
	from the list, as Coscine provides a flat file layout, their file contents
	are included and the presence of the directory is indicated by the
	prefix in the Path column.
</p>
<p>
	The table provides download links valid for 24 hours after the site
	was generated for all the files contained in the table.
</p>

<div class="table-container">
	<table id="file-table" style="margin-bottom: 0px;">
		<tr>
			<th>Path</th>
			<th>Filetype</th>
			<th>Created</th>
			<th>Modified</th>
			<th>Size</th>
			<th>Download</th>
		</tr>
		<tr>
			<td><input type="text" id="filter_0" onkeyup="filter_table(0)" placeholder="Filter..."/></td>
			<td><input type="text" id="filter_1" onkeyup="filter_table(1)" placeholder="Filter..."/></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
		</tr>
		{% for item in files %}
		<tr>
			<td>{{item.path}}</td>
			<td>{{item.filetype}}</td>
			<td>{{item.created.strftime('%Y-%m-%d')}}</td>
			<td>{{item.modified.strftime('%Y-%m-%d')}}</td>
			<td>{{item.size | filesizeformat}}</td>
			<td style="text-align: center">
				<a href="{{item.download_url}}"><button>Download</button></a>
			</td>
		</tr>
		{% endfor %}
	</table>
</div>

<p>
	<i>Total number of files:</i> <b>{{files | length}}</b>
</p>


<p>
	The index of the files listed in the table is downloadable in various
	formats using the format selector and button below.
	Although no cumulative download of the files is technically possible,
	their download URLs can easily be iterated over via a script after
	downloading the index in i.e. json format.
</p>

<div>
	<label for="file-formats">Format:</label>
	<select id="file-formats" onchange="change_link('file-formats', 'download-file-link')">
		<option value="download/files.csv">CSV</option>
		<option value="download/files.json">JSON</option>
		<option value="download/files.xlsx">MS Excel XLSX</option>
		<option value="download/files.html">HTML</option>
	</select>
	<a href="download/files.csv" id="download-file-link">
		<button>Download</button>
	</a>
</div>


<h2>Metadata Interface</h2>
<p>
	Enter a <a href="https://www.w3.org/TR/2013/REC-sparql11-query-20130321/#basicpatterns">SPARQL</a> query in the code editor below to query the metadata.
	Prefixes present in the raw metadata do not need to be explicitly defined
	in the SPARQL query. However, prefixes present in the application profile
	of the resource are lost and therefore need to be explicitly defined.
	The results of a query are displayed in a dynamically generated table
	below the sparql area.
</p>
<p>
	Metadata Schema: <a href="{{resource_metadata_schema.uri}}">{{resource_metadata_schema.name}}</a>
</p>

<div>
<textarea id="sparql-input" rows="5">
SELECT * WHERE { ?path ?p ?o . } LIMIT 10
</textarea>
<br/>
<button id="submit-query" onclick="query()">Submit</button>
</div>


<div>
	<div id="sparql-result" style="display: none;">
		<h3>SPARQL Query Results</h3>
		<div class="table-container">
			<table id="sparql-result-table"></table>
		</div>
	</div>
	<div id="sparql-error" style="display: none;">
	</div>
</div>

<p>
	The raw metadata of all file objects in the resource can be downloaded
	in various formats using the selector and button below.
</p>

<div>
	<label for="metadata-formats">Format:</label>
	<select id="metadata-formats" onchange="change_link('metadata-formats', 'download-metadata-link')">
		<option value="download/metadata.ttl">Turtle</option>
		<option value="download/metadata.json">JSON-LD</option>
	</select>
	<a href="download/metadata.ttl" id="download-metadata-link">
		<button>Download</button>
	</a>
</div>

<script>
/* filters the file table according to a certain column */
function filter_table(column) {
	const table = document.getElementById("file-table");
	const rows = table.getElementsByTagName("tr");
	const filter = document.getElementById("filter_" + column);
	/* start at row 3, because 0 is header, 1 is filter */
	for(var i = 2; i < rows.length; i++) {
		const cols = rows[i].getElementsByTagName("td");
		if(cols[column].textContent.indexOf(filter.value) > -1) {
			rows[i].style.display = "";
		} else {
			rows[i].style.display = "none";
		}
	}
}

/* Changes the download link according to the selected value */
function change_link(id, link) {
	const formats = document.getElementById(id);
	const download_link = document.getElementById(link);
	download_link.href = formats.value;
}
</script>

<script type="text/javascript" src="static/rdfstore.js"></script>
<script language="javascript" type="text/javascript" src="static/codemirror5/codemirror.js"></script>
<script language="javascript" type="text/javascript" src="static/codemirror5/sparql.js"></script>
<script language="javascript" type="text/javascript" href="static/codemirror5/matchbrackets.js"></script>
<link rel="stylesheet" type="text/css" href="static/codemirror5/codemirror.css"></link>

<script>
/* Handle to the SPARQL code editor */
var editor = CodeMirror.fromTextArea(document.getElementById('sparql-input'), {
	lineNumbers: true,
	mode: "application/sparql-query",
	matchBrackets: true,
});

/* Declaration of global rdf graph for the metadata */
rdfgraph = null;

/* fetch metadata and parse it into an rdf graph */
fetch("download/metadata.ttl").then(response => response.text()).then(
	(metadata) => {
		rdfstore.create(function(err, store){
			store.load("text/turtle", metadata, function(s,d){});
			rdfgraph = store;
		});
	}
);

function query() {
	const result_div = document.getElementById("sparql-result");
	const result_table = document.getElementById("sparql-result-table");
	const result_error = document.getElementById("sparql-error");
	try {
		result_div.style.display = ""; /* make results visible */
		result_error.style.display = "none"; /* hide errors */
		rdfgraph.execute(editor.getValue(), function(success, results){
			result_table.innerHTML = ""; /* Clear table */
			/* Construct table header */
			var header = result_table.createTHead();
			for(var key in results[0]) {
				th = document.createElement("th");
				header.appendChild(th);
				th.textContent = key;
			}
			/* Construct table value rows */
			for(var i = 0; i < results.length; i++) {
				var row = result_table.insertRow(i);
				var j = 0;
				for(var key in results[i]) {
					row.insertCell(j).textContent = results[i][key].value;
					j++;
				}
			}
		});
	} catch(err) {
		result_div.style.display = "none"; /* Hide result table */
		result_error.style.display = ""; /* Make errors visible */
		result_error.textContent = "ERROR: " + err.message;
	}
}

</script>

{% endblock %}
